<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
</head>

<body>
    <h1 id="lblExtention">Detecting extention...</h1>
    <hr>
    <video id="video" style="border: solid 1px; width: 600px; height: 600px;"></video>
    <hr>
    <button style="background-color: black; color: white; font-size: 12pt; padding:1em" id="btnStart">Start</button>
    <script>
        var btn = document.getElementById('btnStart');
        btn.addEventListener('click', () => {
            captureUserMedia(function (stream) {
                var video = document.querySelector('video');
                video.src = window.URL.createObjectURL(stream);
                video.onloadedmetadata = function (e) {
                    video.play();
                };
            },
                function (err) {
                    console.log("The following error occured: " + err.name);
                });
        });

        var isChrome = !!navigator.webkitGetUserMedia;

        var DetectRTC = {};

        (function () {
            var screenCallback;

            DetectRTC.screen = {
                chromeMediaSource: 'screen',
                getSourceId: function (callback) {
                    if (!callback) throw '"callback" parameter is mandatory.';
                    screenCallback = callback;
                    window.postMessage('get-sourceId', '*');
                },
                isChromeExtensionAvailable: function (callback) {
                    if (!callback) return;

                    if (DetectRTC.screen.chromeMediaSource == 'desktop') callback(true);

                    // ask extension if it is available
                    window.postMessage('are-you-there', '*');

                    setTimeout(function () {
                        if (DetectRTC.screen.chromeMediaSource == 'screen') {
                            callback(false);
                        } else callback(true);
                    }, 1000);
                },
                onMessageCallback: function (data) {
                    console.log('chrome message', data);

                    // "cancel" button is clicked
                    if (data == 'PermissionDeniedError') {
                        DetectRTC.screen.chromeMediaSource = 'PermissionDeniedError';
                        if (screenCallback) return screenCallback('PermissionDeniedError');
                        else throw new Error('PermissionDeniedError');
                    }

                    // extension notified his presence
                    if (data == 'rtcmulticonnection-extension-loaded') {
                        DetectRTC.screen.chromeMediaSource = 'desktop';
                    }

                    // extension shared temp sourceId
                    if (data.sourceId) {
                        DetectRTC.screen.sourceId = data.sourceId;
                        if (screenCallback) screenCallback(DetectRTC.screen.sourceId);
                    }
                }
            };
        })();

        window.addEventListener('message', function (event) {
            if (event.origin != window.location.origin) {
                return;
            }
            DetectRTC.screen.onMessageCallback(event.data);
        });

        function captureUserMedia(onStreamApproved, onStreamDenied) {

            var screen_constraints = {
                mandatory: {
                    chromeMediaSource: DetectRTC.screen.chromeMediaSource,
                    maxWidth: screen.width>1920?screen.width:1920,
                    maxHeight: screen.height>1080?screen.height:1080
                },
                optional: []
            };

            if (DetectRTC.screen.chromeMediaSource == 'desktop' && !DetectRTC.screen.sourceId) {
                DetectRTC.screen.getSourceId(function (error) {
                    // if exception occurred or access denied
                    if (error && error == 'PermissionDeniedError') {
                        alert('PermissionDeniedError: User denied to share content of his screen.');
                    }

                    captureUserMedia(onStreamApproved, onStreamDenied);
                });
                return;
            }
            console.log('no extention!')

            // this statement sets gets 'sourceId" and sets "chromeMediaSourceId" 
            if (DetectRTC.screen.chromeMediaSource == 'desktop') {
                screen_constraints.mandatory.chromeMediaSourceId = DetectRTC.screen.sourceId;
            }

            // it is the session that we want to be captured
            // audio must be false
            var session = {
                audio: false,
                video: screen_constraints
            };

            // now invoking native getUserMedia API
            navigator.mediaDevices.getUserMedia(session).then(onStreamApproved).catch(onStreamDenied);
        }

        // check if desktop-capture extension installed.
        if (window.postMessage && isChrome) {
            DetectRTC.screen.isChromeExtensionAvailable(function (result) {
                var label = document.getElementById('lblExtention');
                label.innerText = 'Extention installed: ' + result;
            });
        }
    </script>
</body>

</html>